blob: 47c6925243e82692995a3036beed0f6e0ff1de51 [file] [log] [blame]
# Licensed to the Apache Software Foundation (ASF) under one or more
# contributor license agreements. See the NOTICE file distributed with
# this work for additional information regarding copyright ownership.
# The ASF licenses this file to You under the Apache License, Version 2.0
# (the "License"); you may not use this file except in compliance with
# the License. You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
DAEMON="livy-server"
DESC="Livy Server"
EXEC_PATH="/usr/lib/livy/bin/livy-server"
WORKING_DIR="/var/lib/livy"
CONF_DIR="/etc/livy/conf"
SVC_USER="livy"
PIDFILE="/var/run/livy/livy-livy-server.pid"
generate_prestart_script() {
cat <<'__EOT__'
runuser -s /bin/bash $SVC_USER -c "$EXEC_PATH start"
__EOT__
}
generate_prestop_script() {
cat <<'__EOT__'
su -s /bin/bash $SVC_USER -c "$EXEC_PATH stop"
__EOT__
}
generate_start() {
cat <<'__EOT__'
start() {
[ -x $EXEC_PATH ] || exit $ERROR_PROGRAM_NOT_INSTALLED
[ -d $CONF_DIR ] || exit $ERROR_PROGRAM_NOT_CONFIGURED
export SPARK_HOME=/usr/lib/spark
export LIVY_LOG_DIR=/var/log/livy
export LIVY_PID_DIR=/var/run/livy
runuser -s /bin/bash $SVC_USER -c "cd $WORKING_DIR && $EXEC_PATH start"
# Some processes are slow to start
sleep $SLEEP_TIME
checkstatusofproc
RETVAL=$?
if [ $RETVAL -eq $STATUS_RUNNING ]; then
touch $LOCKFILE
log_success_msg "Started ${DESC}: "
else
log_failure_msg "Failed to start ${DESC}. Return value: $RETVAL"
fi
return $RETVAL
}
__EOT__
}
generate_stop() {
cat <<'__EOT__'
stop() {
runuser -s /bin/bash $SVC_USER -c "$EXEC_PATH stop"
RETVAL=$?
if [ $RETVAL -eq $RETVAL_SUCCESS ]; then
log_success_msg "Stopped ${DESC}: "
rm -f $LOCKFILE $PIDFILE
else
log_failure_msg "Failed to stop ${DESC}. Return value: $RETVAL."
fi
}
__EOT__
}